/*#include "colors.inc"
#include "metals.inc"
#include "skies.inc"
#include "textures.inc"
   
camera {location <-5,6,-5> look_at<2,6,0>}

light_source {<-400,60,-150> color White}
sky_sphere{S_Cloud2}                   
       */     
#declare bend =
        difference {
                torus {.5,.5 rotate 90*z}
                box {<-2,-2,-2>,<2,0,2>}
                box {<-2,-2,0>,<2,2,2>}
                }
                
#declare leg =
        difference {
                union {
                        cylinder {<0,-.5,0><0,2,0>,.55}
                        cylinder {<0,-2,0><0,.5,0>,.6}                                 
                        }
                box {<-1,-2.5,0>,<1,2.5,1>}
                }
                
#declare elbow =
        union {
                cylinder {<0,-.9,0>,<0,.9,0>.5}
                cylinder {<0,0,0>,<-1,0,0>.5}
                torus {.5,.1 rotate 90*z translate -1*x}
                torus {.5,.1 translate .9*y}
                torus {.5,.1 translate -.9*y}
                difference {
                        union {
                                cone {<0,.9,0>,.4 <0,1.8,0>,.15}   
                                cylinder {<0,.9,0>,<0,1.6,0>.4}
                                }
                        box {<-1.5,1.1,-1.5>,<-.275,1.65,1.5>}
                        box {<.275,1.1,-1.5>,<1.5,1.65,1.5>}
                        rotate -25*y
                        
                        pigment{P_Brass1} finish{F_MetalB}
                        }
                cylinder {<0,1.6,0>,<0,2.1,0>.125 pigment {P_Chrome3} finish {F_MetalB}}
                cylinder {<0,2.05,0>,<0,2.2,0>.6 pigment {color Black} finish {Dull}}
                torus {.58,.02 translate 2.2*y pigment {color Black} finish {Dull}}
                cylinder {<0,2.05,0>,<0,2.22,0>.58 pigment {color Black} finish {Dull}}        
                }
                
#declare releasevalve = 
        union {
                difference {
                        union {
                                cone {<0,.9,0>,.4 <0,1.8,0>,.15}   
                                cylinder {<0,.9,0>,<0,1.6,0>.4}
                                }
                        box {<-1.5,1.1,-1.5>,<-.275,1.65,1.5>}
                        box {<.275,1.1,-1.5>,<1.5,1.65,1.5>}
                        rotate -25*y
                        
                        pigment{P_Brass1} finish{F_MetalB}
                        }
                cylinder {<0,1.6,0>,<0,2.1,0>.125 pigment {P_Chrome3} finish {F_MetalB}}
                cylinder {<0,2.05,0>,<0,2.2,0>.6 pigment {color Black} finish {Dull}}
                torus {.58,.02 translate 2.2*y pigment {color Black} finish {Dull}}
                cylinder {<0,2.05,0>,<0,2.22,0>.58 pigment {color Black} finish {Dull}} 
                }                                
                 
#declare part =
        union {   
                object {bend rotate 180*x translate <0,-8.5,2>}
                object {bend rotate 90*x translate <0,8.5,2>}
                object {bend rotate -90*x translate <0,-8.5,-2>}
                object {bend translate <0,8.5,-2>}
                cylinder {<0,-8.5,-2.5>,<0,8.5,-2.5>,.5}
                cylinder {<0,-8.5,2.5>,<0,8.5,2.5>,.5}
                cylinder {<0,-9,0>,<0,9,0>,.7}
                cylinder {<0,9,-2>,<0,9,2>,.5}
                cylinder {<0,-9,-2>,<0,-9,2>,.5}
                cylinder {<0,0,-2.5>,<0,0,2.5>.4} 
                //cylinder {<0,4.5,-2.5>,<0,4.5,2.5>.4}
                //cylinder {<0,-4.5,-2.5>,<0,-4.5,2.5>.4}
                scale .8*x
                }
 

#declare ho=0;        
                     
#declare radiator =            
union {
 #while (ho < 22)
  object {part translate ho*x}
  #declare ho = ho + 1.5;
 #end
cylinder {<0,9,0><21,9,0>.7}  
cylinder {<0,-9,0><21,-9,0>.7}
object {leg translate <0,-9,-2.5>} 
object {leg translate <21,-9,-2.5>}
object {leg rotate 180*y translate <0,-9,2.5>}
object {leg rotate 180*y translate <21,-9,-2.5>}
torus {.6, .1 rotate 90*z translate <-1,-9,0>}
cylinder {<0,-9,0>,<-1,-9,0>,.7}
cylinder {<-1,-9,0>,<-1.1,-9,0>,.6} 
torus {.6, .1 rotate 90*z translate <-1,9,0>}
cylinder {<0,9,0>,<-1,9,0>,.7}
cylinder {<-1,9,0>,<-1.1,9,0>,.6} 

torus {.6, .1 rotate 90*z translate <22,9,0>}
cylinder {<21,9,0>,<22,9,0>,.7}
cylinder {<22,9,0>,<22.1,9,0>,.6}
torus {.6, .1 rotate 90*z translate <22,-9,0>}
cylinder {<21,-9,0>,<22,-9,0>,.7}
cylinder {<22,-9,0>,<22.1,-9,0>,.6}
  
cylinder {<-1,-9,0>,<-1.8,-9,0>,.3 pigment{P_Brass1} finish{F_MetalA}}
object {elbow rotate 180*y translate <-2.75,-9,0> pigment{P_Brass1} finish{F_MetalA}}
cylinder {<-2.75,-9,0>,<-2.75,-12,0>,.3 pigment{P_Brass1} finish{F_MetalA}}
object {releasevalve rotate -90*z translate <21,9,0>}
scale 1.5
} 

//object {radiator pigment {color White}}
                
#declare baseboard = 
difference {
        union {
                box {<-10,2.4,-.75><10,4.25,0>rotate 6*x}
                box {<-10,0,-.7><10,2.5,0>}
                cylinder {<-10,0,-.75><10,0,-.75>,.5}
                cylinder {<-10,4,-.35><10,4,-.35>,.3}
                }
        box {<-11,-1,0><11,6,2>}  
        box {<-11,-1,0><11,0,-2>}
        }
        
//object {baseboard pigment {color White}} 

#declare Stairs =
union {
        difference {
                union {
                        cylinder {<-2,6,0>,<4.2,6,0>,.5  }
                        box {<-2,0,-1>,<4,6,0>}
                        }
                box {<0,-10,-2>,<6,10,1> rotate -22.5*z translate 1.26*x} 
                }
        difference {
                union {     
                        cylinder {<3.8,6,0>,<40,6,0>,.5  }
                        box {<4,-10,-1>,<40,6,0>}
                        }
                box {<0,-10,-2>,<4,10,1> rotate 22.5*z translate 2.25*x} 
                rotate -45*z translate <-3.4,4.65,-.02>
                }
        } 
        
//object {Stairs}         
                        